unit mStrGridSel_;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, ExtCtrls, Buttons, mStrGrid, Menus, ComCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    StringGrid1: TStringGrid;
    RadioGroup1: TRadioGroup;
    Label1: TLabel;
    AbortBtn: TBitBtn;
    StringGrid2: TStringGrid;
    Label2: TLabel;
    mStrGrid1: TmStrGrid;
    Select1_1: TButton;
    Get_1_1_Selection: TButton;
    UnSelect1_1: TButton;
    CursorLeftRight: TUpDown;
    CursorUpDown: TUpDown;
    FixedLeftRight: TUpDown;
    FixedUpDown: TUpDown;
    UnselectBtn: TButton;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure AbortBtnClick(Sender: TObject);
    procedure Select1_1Click(Sender: TObject);
    procedure Get_1_1_SelectionClick(Sender: TObject);
    procedure UnSelect1_1Click(Sender: TObject);
    procedure CursorLeftRightClick(Sender: TObject; Button: TUDBtnType);
    procedure CursorUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure FixedLeftRightClick(Sender: TObject; Button: TUDBtnType);
    procedure FixedUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure UnselectBtnClick(Sender: TObject);
    procedure CursorLeftRightChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure CursorUpDownChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure FixedLeftRightChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure FixedUpDownChanging(Sender: TObject;
      var AllowChange: Boolean);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses Clipbrd;

procedure TForm1.FormCreate(Sender: TObject);
var c,r:integer;
begin with mStrGrid1 do
begin for c:=1 to colCount-1 do
       cells[c,0]:=chr(64+c);
      for r:=1 to rowcount-1 do
       cells[0,r]:=inttostr(r);
      for c:=1 to colCount-1 do
       for r:=1 to rowcount-1 do
        cells[c,r]:=inttostr(round(random(1000)));
      RadioGroup1Click(Sender)
end end;

procedure TForm1.Timer1Timer(Sender: TObject);
var c,r:integer;
begin with mStrGrid1 do
begin {New Selection}
      for c:=0 to colcount-1 do
      for r:=0 to rowcount-1 do
      if selected[c,r] then stringgrid1.cells[c,r]:='*'
                       else stringgrid1.cells[c,r]:=' ';
      stringgrid1.row:=row;
      stringgrid1.col:=col;
      {Old selection}
      with selection do
      begin {rows before range}
            for r:=0 to top-1 do
              for c:=0 to colcount-1 do stringgrid2.cells[c,r]:=' ';
            {rows in range}
            for r:=top to bottom do
              begin for c:=0 to left-1 do stringgrid2.cells[c,r]:=' ';
                    for c:=left to right do stringgrid2.cells[c,r]:='*';
                    for c:=right+1 to colcount-1 do stringgrid2.cells[c,r]:=' ';
              end;
            {rows after range}
            for r:=bottom+1 to rowcount-1 do
              for c:=0 to colcount-1 do stringgrid2.cells[c,r]:=' ';
            stringgrid2.row:=row;
            stringgrid2.col:=col;
end end end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin with radioGroup1 do
      mStrGrid1.SelectMethod:=TmSelectMethod(itemindex);
      if sender=RadioGroup1 then mStrGrid1.SetFocus
end;

procedure TForm1.AbortBtnClick(Sender: TObject);
begin
close
end;

procedure TForm1.Select1_1Click(Sender: TObject);
begin mStrGrid1.selected[1,1]:=true end;

procedure TForm1.Get_1_1_SelectionClick(Sender: TObject);
begin if mStrGrid1.selected[1,1]
      then Showmessage('cell[1,1] is selected')
      else Showmessage('cell[1,1] is not selected')
end;

procedure TForm1.UnSelect1_1Click(Sender: TObject);
begin mStrGrid1.selected[1,1]:=false end;

procedure TForm1.CursorLeftRightChanging(Sender: TObject;  var AllowChange: Boolean);
{called first}
begin CursorLeftRight.position:=mStrGrid1.col;
      CursorLeftRight.min:=mStrGrid1.fixedcols;
      CursorLeftRight.max:=mStrGrid1.ColCount-1;
end;

procedure TForm1.CursorLeftRightClick(Sender: TObject; Button: TUDBtnType);
{called next}
begin mStrGrid1.col:=CursorLeftRight.position end;

procedure TForm1.CursorUpDownChanging(Sender: TObject;  var AllowChange: Boolean);
{called first}
begin CursorUpDown.position:=mStrGrid1.row;
      CursorUpDown.min:=mStrGrid1.fixedrows;
      CursorUpDown.max:=mStrGrid1.rowCount-1;
end;

procedure TForm1.CursorUpDownClick(Sender: TObject; Button: TUDBtnType);
{called next}
begin mStrGrid1.row:=CursorUpDown.position end;

procedure TForm1.FixedLeftRightChanging(Sender: TObject;  var AllowChange: Boolean);
{called first}
begin FixedLeftRight.position:=mStrGrid1.fixedCols;
      FixedLeftRight.max:=mStrGrid1.ColCount-1
end;

procedure TForm1.FixedLeftRightClick(Sender: TObject; Button: TUDBtnType);
{called next}
begin mStrGrid1.fixedCols:=FixedLeftRight.position end;

procedure TForm1.FixedUpDownChanging(Sender: TObject;  var AllowChange: Boolean);
{called first}
begin FixedUpDown.position:=mStrGrid1.fixedRows;
      FixedUpDown.max:=mStrGrid1.RowCount-1
end;

procedure TForm1.FixedUpDownClick(Sender: TObject; Button: TUDBtnType);
{called next}
begin mStrGrid1.FixedRows:=FixedUpDown.position end;

procedure TForm1.UnselectBtnClick(Sender: TObject);
begin mstrgrid1.unselect end;


end.
